summaryrefslogtreecommitdiffstats
path: root/games/devilutionx
diff options
context:
space:
mode:
Diffstat (limited to 'games/devilutionx')
-rw-r--r--games/devilutionx/README15
-rw-r--r--games/devilutionx/devilutionx.SlackBuild141
-rw-r--r--games/devilutionx/devilutionx.info22
-rw-r--r--games/devilutionx/doinst.sh9
-rw-r--r--games/devilutionx/slack-desc19
5 files changed, 206 insertions, 0 deletions
diff --git a/games/devilutionx/README b/games/devilutionx/README
new file mode 100644
index 0000000000..0403a95fab
--- /dev/null
+++ b/games/devilutionx/README
@@ -0,0 +1,15 @@
+DevilutionX is a source port of Diablo and Hellfire that strives to
+make it simple to run the game while providing engine improvements,
+bugfixes, and some optional quality of life features.
+
+Check out the manual (https://github.com/diasurgical/devilutionX/wiki)
+for what features are available and how best to take advantage of
+them.
+
+You'll need access to the data from the original game. If you don't
+have an original CD then you can buy Diablo from GoG.com. Alternately
+you can use spawn.mpq from the shareware version, in place of
+DIABDAT.MPQ, to play the shareware portion of the game.
+
+Place mpqs in: $HOME/.local/share/diasurgical/devilution/ or
+/usr/share/diasurgical/devilutionx/
diff --git a/games/devilutionx/devilutionx.SlackBuild b/games/devilutionx/devilutionx.SlackBuild
new file mode 100644
index 0000000000..7a37e1e49f
--- /dev/null
+++ b/games/devilutionx/devilutionx.SlackBuild
@@ -0,0 +1,141 @@
+#!/bin/bash
+
+# Slackware build script for devilutionx
+
+# Copyright 2022-2024 Steven Voges <Oregon, USA>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=devilutionx
+SRCNAM=devilutionX
+VERSION=${VERSION:-1.5.2}
+LIBMPQ=${LIBMPQ:-b78d66c6fee6a501cc9b95d8556a129c68841b05}
+LIBSMACKERDEC=${LIBSMACKERDEC:-91e732bb6953489077430572f43fc802bf2c75b2}
+LIBZT=${LIBZT:-d6c6a069a5041a3e89594c447ced3f15d77618b8}
+ZEROTIERONE=${ZEROTIERONE:-b0b342579adf6cec3ee26ec7c6148ec66d01709f}
+LWIP=${LWIP:-32708c0a8b140efb545cc35101ee5fdeca6d6489}
+LWIPCONTRIB=${LWIPCONTRIB:-a57a8a213067912168baf978864a6f1adaacc042}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+DEPS=$TMP/$SRCNAM-$VERSION/build/_deps
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+
+mkdir -p $DEPS/libmpq-subbuild/libmpq-populate-prefix/src
+mkdir -p $DEPS/libsmackerdec-subbuild/libsmackerdec-populate-prefix/src
+mkdir -p $DEPS/libzt-src/ext/ZeroTierOne
+mkdir -p $DEPS/libzt-src/ext/lwip
+mkdir -p $DEPS/libzt-src/ext/lwip-contrib
+
+tar xvf $CWD/libmpq-$LIBMPQ.tar.gz -C \
+ $DEPS/libmpq-subbuild/libmpq-populate-prefix/src --strip-components 1
+tar xvf $CWD/libsmackerdec-$LIBSMACKERDEC.tar.gz -C \
+ $DEPS/libsmackerdec-subbuild/libsmackerdec-populate-prefix/src --strip-components 1
+tar xvf $CWD/libzt-$LIBZT.tar.gz -C \
+ $DEPS/libzt-src --strip-components 1
+tar xvf $CWD/ZeroTierOne-$ZEROTIERONE.tar.gz -C \
+ $DEPS/libzt-src/ext/ZeroTierOne --strip-components 1
+tar xvf $CWD/lwip-$LWIP.tar.gz -C \
+ $DEPS/libzt-src/ext/lwip --strip-components 1
+tar xvf $CWD/lwip-contrib-$LWIPCONTRIB.tar.gz -C \
+ $DEPS/libzt-src/ext/lwip-contrib --strip-components 1
+
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DBUILD_ASSETS_MPQ=ON \
+ -DBUILD_TESTING=OFF \
+ -DFETCHCONTENT_FULLY_DISCONNECTED=ON \
+ -DFETCHCONTENT_QUIET=OFF \
+ -DFETCHCONTENT_SOURCE_DIR_LIBMPQ=$DEPS/libmpq-subbuild/libmpq-populate-prefix/src \
+ -DFETCHCONTENT_SOURCE_DIR_LIBSMACKERDEC=$DEPS/libsmackerdec-subbuild/libsmackerdec-populate-prefix/src \
+ -DFETCHCONTENT_SOURCE_DIR_LIBZT=$DEPS/libzt-src \
+ -DVERSION_NUM=${VERSION} \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/usr/share/diasurgical/$PRGNAM/README.txt
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ *.md VERSION docs \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/games/devilutionx/devilutionx.info b/games/devilutionx/devilutionx.info
new file mode 100644
index 0000000000..47dcc77aaf
--- /dev/null
+++ b/games/devilutionx/devilutionx.info
@@ -0,0 +1,22 @@
+PRGNAM="devilutionx"
+VERSION="1.5.2"
+HOMEPAGE="https://github.com/diasurgical/devilutionX"
+DOWNLOAD="https://github.com/diasurgical/devilutionX/archive/1.5.2/devilutionX-1.5.2.tar.gz \
+ https://github.com/diasurgical/libmpq/archive/b78d66c6fee6a501cc9b95d8556a129c68841b05/libmpq-b78d66c6fee6a501cc9b95d8556a129c68841b05.tar.gz \
+ https://github.com/diasurgical/libsmackerdec/archive/91e732bb6953489077430572f43fc802bf2c75b2/libsmackerdec-91e732bb6953489077430572f43fc802bf2c75b2.tar.gz \
+ https://github.com/diasurgical/libzt/archive/d6c6a069a5041a3e89594c447ced3f15d77618b8/libzt-d6c6a069a5041a3e89594c447ced3f15d77618b8.tar.gz \
+ https://github.com/diasurgical/ZeroTierOne/archive/b0b342579adf6cec3ee26ec7c6148ec66d01709f/ZeroTierOne-b0b342579adf6cec3ee26ec7c6148ec66d01709f.tar.gz \
+ https://github.com/diasurgical/lwip/archive/32708c0a8b140efb545cc35101ee5fdeca6d6489/lwip-32708c0a8b140efb545cc35101ee5fdeca6d6489.tar.gz \
+ https://github.com/diasurgical/lwip-contrib/archive/a57a8a213067912168baf978864a6f1adaacc042/lwip-contrib-a57a8a213067912168baf978864a6f1adaacc042.tar.gz"
+MD5SUM="152f40d6648badaf79a4edb0b8e9633b \
+ da531a1a6f719e89798a26e679ffc329 \
+ c3b1ecbe702266e149b158178a03e2b3 \
+ 91089ccbb3edd29bfbdcd535ae0be2f5 \
+ 5e61d98f6635e135f8cfe62f77a669f3 \
+ 688cda39d46a1b2fdf23c1cdafbf6cfb \
+ ee5e810b1d00123bc6fc5c66ca84f967"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="SDL_audiolib asio simpleini smpq"
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"
diff --git a/games/devilutionx/doinst.sh b/games/devilutionx/doinst.sh
new file mode 100644
index 0000000000..65c7e2eeb9
--- /dev/null
+++ b/games/devilutionx/doinst.sh
@@ -0,0 +1,9 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ /usr/bin/gtk-update-icon-cache -f usr/share/icons/hicolor >/dev/null 2>&1
+ fi
+fi
diff --git a/games/devilutionx/slack-desc b/games/devilutionx/slack-desc
new file mode 100644
index 0000000000..f9d43cda09
--- /dev/null
+++ b/games/devilutionx/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+devilutionx: devilutionx (Diablo build for modern operating systems)
+devilutionx:
+devilutionx: DevilutionX is a source port of Diablo and Hellfire that strives to
+devilutionx: make it simple to run the game while providing engine improvements,
+devilutionx: bugfixes, and some optional quality of life features.
+devilutionx:
+devilutionx: Homepage: https://github.com/diasurgical/devilutionX
+devilutionx:
+devilutionx:
+devilutionx:
+devilutionx: